/*
 * Operationen ueber gemeine Brueche
 * Berechnung zweier Brueche                                      */
 * unter Verwendung der Funktionen aus bruch.h
 */

#include <stdio.h>
#include "bruch.h"

int main()
{
  struct bruch b1[] = {{3,1},{3,2},{5,12},{1,4},{1,8},
                       {7,2},{7,8},{5,2}};
  struct bruch b2[] = {{9,2},{1,3},{7,3},{7,1},{3,2},
                       {7,9},{3,1},{11,3},{5,2}};
  struct bruch b;

  printf( "TestBruch 1\n");
  b = div(add(mult(b1[0],b1[1]),
              mult(b1[2], add(neg(add(b1[3],b1[4])),
                              add(b1[5],b1[6])))),
          b1[7]);
  bruchAusgabe( b);


  printf( "\nTestBruch 2\n");
  b = inverse(sub(add(add(mult(b2[0],b2[1]),b2[2]),
                      div(b2[3],b2[4])),
                  add(add(mult(b2[5],b2[6]),b2[7]),
                      b2[8])));
  bruchAusgabe( b);

  printf( "\n");
  return 0;
}

/*
   TestBruch 1
   37/15
   TestBruch 2
   NaN
*/