/*
 * Exponentialfunktion e hoch x
 * Aufruf: gcc -Wall -O exptab_verbessert.c -o exptab -lm
 */

# include <stdio.h>
# include <math.h>       /* mathematische Funktionen */

/* # define ITEM float */
# define ITEM double

                  /* verbesserte Exponentialfunktion */
ITEM myexp_verbessert( double);


/*
 * Rahmenprogramm zur Exponentialfunktion
 */
int main()
{
  double x ;                             /* Argument */
  char c[ 2] ;                        /* Abbruch j/n */

/* Vorbereitung                         Ueberschrift */
  printf( "\nExponentialfunktion - e hoch x  -\n");

/* Eingabe */
  do
  {
    printf( "\nx = ");
    scanf( "%lf", &x);                 /* Eingabe: x */

/* Verarbeitung und Ausgabe*/
/* Vergleich mit Standardfunktion aus <math.h> */
    printf( "e ^ %f = %f, %f\n",
             x, myexp_verbessert( x), exp( x));

/* Nachbereitung */
    printf( "Noch einmal j/n? ");
    scanf( "%s", c);
  } while( c[ 0] == 'j');

  return 0;
}

/*
 * Exponentialfunktion (Reihenentwicklung)
 * e hoch x = 1 + x + x hoch 2 / 2! + x hoch 3 / 3! ...
 */
ITEM myexp_verbessert( double xx)
{
  ITEM summeAlt, summeNeu = 1, summand = 1;
  int i = 1; double xxx;

  if( xx < 0) xxx = -xx; else xxx = xx;

  do                            /* Reihenentwicklung */
  { summeAlt = summeNeu;
    summand *= xxx / i++;
    summeNeu += summand;
  } while(( summeNeu != summeAlt)/* && (i < 100)*/);

  if( xx < 0) return 1 / summeAlt;
  else return summeAlt;
}

/*
   Exponentialfunktion - e hoch x  -

   x = e ^ 1.000000 = 2.718282, 2.718282
   Noch einmal j/n? 
   x = e ^ -10.000000 = 0.000045, 0.000045
   Noch einmal j/n? 
*/