/*
 * Skalarproduktberechnung
 */

# include <stdio.h>

# include "vektorio.h"


# define MAXZAHL 10               /* Makrodefinition */


/*
 * Funktion 'scalarprodukt'

 * Berechnung das Scalarprodukt zweier Vektoren

 * Parameter:   Zeiger auf einen Vektor

 *              Zeiger auf einen zweiten Vektor

 *              Laenge des Vektors

 * Rueckgabe:   Scalarprodukt
 */

float scalarprodukt( float *, float *, unsigned int n);



/*
 * Funktion 'scalarproduktAusgabe'

 * Ausgabe des Scalarprodukt zweier Vektoren

 * Parameter:   Zeiger auf einen Vektor

 *              Zeiger auf einen zweiten Vektor

 *              Laenge des Vektors
 */

void scalarproduktAusgabe
  ( float *, float *, unsigned int);



int main()

{
  unsigned int Anzahl1, Anzahl2;

  float Vektor1[ MAXZAHL], Vektor2[ MAXZAHL];

  while((Anzahl1 = vektorEingabe( Vektor1, MAXZAHL)) > 0)

  { Anzahl2 = vektorEingabe( Vektor2, MAXZAHL);

    if (Anzahl1 != Anzahl2)

      printf("\nVektoren mssen gleich lang sein!\n\n");

    else

      scalarproduktAusgabe( Vektor1, Vektor2, Anzahl1);

  }

  return 0;

}



/*
 * Funktion 'scalarprodukt'
 */

float scalarprodukt
  ( float *V1, float *V2, unsigned int n)

{
  unsigned int i; float Summe = 0;

  for( i = 0; i < n; i++) Summe += V1[i] * V2[i];

  return Summe;

}

    

/*
 * Funktion 'scalarproduktAusgabe'
 */

void scalarproduktAusgabe
  ( float *V1, float *V2, unsigned int n)

{
  printf( "\nDas Scalarprodukt der beiden Vektoren\n");

  vektorAusgabe( V1, n);

  printf( "und\n");

  vektorAusgabe( V2, n);

  printf( "\nist %7.2f.\n\n",
           scalarprodukt( V1, V2, n));

  return;

}

