/*
 * Euklidscher Algorithmus
 * Implementation der Funktionen aus euklid.h
 */

#include <stdio.h>
#include "euklid.h"

/*
 * Berechnung und Rckgabe des ggT zweier Zahlen
 */
unsigned int ggT (unsigned int r0, unsigned int r1)
{
  unsigned int r2;

  while (r1 != 0)
  {
    r2 = r0 % r1;
    r0 = r1; r1 = r2;
  }
  return r0;
  
}

/*
 * Berechnung und Rckgabe des kgV zweier Zahlen
 */
unsigned int kgV (unsigned int r0, unsigned int r1)
{
  unsigned int g;
  g = ggT( r0,r1);
  return ( g != 0) ? r0 / g * r1 : 0;
}
