# include <stdio.h>
# include <math.h>
# define M_PI 3.14159265359

int main()
{
  double a = 8, x;

  printf( "a * a = %f  ", a * a);       /* 64.000000 */
  printf( "a^2=%f\n", pow( a, 2));      /* 64.000000 */
  printf( "%f^%d = %f\n", a, 10, pow( a, 10));
                                /* 1073741824.000000 */

  printf( "Quadratwurzel aus %f = %f\n", a, sqrt( a));
                                         /* 2.828427 */
  printf( "%d.Wurzel aus %f = %f\n",
          3, a, pow( a, 1./3));          /* 2.000000 */

  x = M_PI / 2;
  printf( "%f\n", ( a * a * a - 1) / ( 1 + sin( x)));
                                       /* 255.500000 */

  printf( "1 / tan( x) = cot( x) = %f\n",
           1 / tan( x));                 /* 0.000000 */

  return 0;
}
