/*
 * Berechnung aller Permutationen von [ 1, 6 ]
 */
#include <stdio.h>
#define PERMUTATION_SIZE 6

int P[ PERMUTATION_SIZE];
int erlaubt( int, int);
void permutationAusgabe();
void permutation( int);


int main()
{
  permutation( 1);
  return 0;
}

/*
 * Funktion ' erlaubt '
 */

int erlaubt( int z, int i)
{ int j;
  for( j = 0; j < (i - 1); j++)
    if( P[j] == z) return 0;
  return 1;
}

/*
 * Funktion ' permutationAusgabe '
 */

void permutationAusgabe()
{
  int i;
  for(i = 0; i < PERMUTATION_SIZE; i++)
  {
    if( i < ( PERMUTATION_SIZE - 1))
      printf( "%d ", P[ i]);
    else printf( "%d\n", P[ i]); 
  }
}

/*
 * rekursitve Funktion ' permutation '
 */

void permutation( int i)
{
  int j;
  if( i > PERMUTATION_SIZE) permutationAusgabe();
  else 
  { for( j = 1; j <= PERMUTATION_SIZE; j++)
      if( erlaubt( j, i))
      {
        P[ i - 1] = j; permutation( i + 1);
      }
  }
  return; 
}
