/*
 * Der Einarmige Bandit
 * Anfangkapital: 300 Euro
 * Sind alle drei Zahlen gleich, wird das Vierfache,
 * sind zwei Zahlen gleich, so das Doppelte
 * des Einsatzes zurckgezahlt,
 * sonst wird der Einsatz vom Kapital abgezogen.
 * Das Spiel endet, falls das Kapital aufgebraucht
 * wurde bzw. falls es 500 Euro ueberschreitet.
 */

# include <stdio.h>
# include <stdlib.h>
# include <time.h>

int main()
{
  unsigned int Zahl1, Zahl2, Zahl3;
  unsigned int Kapital = 300, Einsatz, Runden = 0, F;
  char Enter;

  srand(( int) time(( time_t) NULL));
  fflush( stdin);

  printf( "Der Einarmige Bandit\n\n");

  do
  {
    do
    {
      printf( "Du hast ein Kapital von %d Euro!\n",
               Kapital);
      printf( "Dein Einsatz: ");
      scanf( "%d", &Einsatz);
    } while( Kapital < Einsatz || Einsatz <= 0);

    Runden++; F = 1; Kapital -= Einsatz;
    printf( "Halt!(ENTER)\n"); scanf( "%c", &Enter);

    Zahl1 = rand() % 9 + 1;
    Zahl2 = rand() % 9 + 1;
    Zahl3 = rand() % 9 + 1;

    printf( "%d  %d  %d\n", Zahl1, Zahl2, Zahl3);

    if( Zahl1 == Zahl2) F++;
    if( Zahl1 == Zahl3) F++;
    if( Zahl2 == Zahl3) F++;

    printf( "%d\n", F);

    if( F != 1) Kapital += F * Einsatz;

  } while( Kapital > 0 && Kapital < 500);

  if( Kapital <= 0)
    printf( "%d Runden und Du bist Pleite!\n", Runden);
  if( Kapital >= 500)
  {
    printf( "%d Runden und der Bandit ist Pleite!\n",
             Runden);
    printf( "Du hast ein Kapital von %d Euro!\n",
             Kapital);
  }

  return 0;
}
