/*
 * Ein-/Ausgabefuntionen fuer unsigned long Werte
 * Header fuer uintio.c
 */

#ifndef _UINTIO_H_
#define _UINTIO_H_

/*
 * Eingabe eines unsigned long Wertes
 * Gibt die Meldung aus und liest einen Integerwert
 * ein, dieser wird zurckgeliefert.
 */
unsigned int uintEingabe( const char *);

/*
 * Ausgabe eines unsigned long Wertes
 * Gibt die Meldung, gefolgt von einer Zahl aus.
 */
void uintAusgabe( const char *, unsigned int);

#endif
